/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.43
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.21 2009/05/29 10:29:10 dagger Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.43 2010/09/15 11:06:33 reavertm Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
14 14
15inherit kde4-base versionator 15inherit kde4-base versionator
16 16
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18 18
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33
34# Add khelpcenter dependency when installing
35if [[ ${PN} != khelpcenter ]] && has doc ${IUSE//+} && use doc; then
36 RDEPEND="${RDEPEND}
37 >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=]
38 "
39fi
40 20
41# Add dependencies that all packages in a certain module share. 21# Add dependencies that all packages in a certain module share.
42case ${KMNAME} in 22case ${KMNAME} in
43 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic) 23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
44 DEPEND="${DEPEND} 24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
45 >=kde-base/qimageblitz-0.0.4
46 "
47 RDEPEND="${RDEPEND}
48 >=kde-base/qimageblitz-0.0.4
49 "
50 ;; 25 ;;
51 kdenetwork) 26 kdepim|kdepim-runtime)
52 DEPEND="${DEPEND}
53 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
54 "
55 RDEPEND="${RDEPEND}
56 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
57 "
58 ;;
59 kdepim)
60 DEPEND="${DEPEND}
61 dev-libs/boost
62 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
63 "
64 RDEPEND="${RDEPEND}
65 dev-libs/boost
66 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
67 "
68 case ${PN} in 27 case ${PN} in
69 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 28 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
70 IUSE="+kontact" 29 IUSE+=" +kontact"
71 RDEPEND="${RDEPEND} 30 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
72 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
73 "
74 ;; 31 ;;
75 esac 32 esac
76 ;; 33 ;;
77 kdegames) 34 kdegames)
78 if [[ ${PN} != libkdegames ]]; then 35 if [[ ${PN} != libkdegames ]]; then
79 DEPEND="${DEPEND} 36 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
80 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
81 "
82 RDEPEND="${RDEPEND}
83 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
84 "
85 fi 37 fi
86 ;; 38 ;;
87 koffice) 39 koffice)
88 [[ ${PN} != koffice-data ]] && IUSE="debug" 40 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
89 RDEPEND="${RDEPEND} 41 RDEPEND+="
90 !app-office/${PN}:0 42 !app-office/${PN}:0
91 !app-office/koffice:0 43 !app-office/koffice:0
92 !app-office/koffice-meta:0 44 !app-office/koffice-meta:0
93 " 45 "
94 if has openexr ${IUSE//+}; then 46 if has openexr ${IUSE//+}; then
95 COMMON_DEPEND="media-gfx/imagemagick[openexr?]" 47 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
96 else 48 else
97 COMMON_DEPEND="media-gfx/imagemagick" 49 COMMONDEPEND+=" media-gfx/imagemagick"
98 fi 50 fi
99 51
100 COMMON_DEPEND="${COMMON_DEPEND} 52 COMMONDEPEND+="
101 dev-cpp/eigen:2 53 dev-cpp/eigen:2
102 media-libs/fontconfig 54 media-libs/fontconfig
103 media-libs/freetype:2 55 media-libs/freetype:2
104 " 56 "
105 DEPEND="${DEPEND} ${COMMON_DEPEND}"
106 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
107 unset COMMON_DEPEND
108 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 57 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
109 DEPEND="${DEPEND}
110 >=app-office/koffice-libs-${PV}:${SLOT} 58 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
111 "
112 RDEPEND="${RDEPEND}
113 >=app-office/koffice-libs-${PV}:${SLOT}
114 "
115 fi 59 fi
116 ;; 60 ;;
117esac 61esac
62
63DEPEND+=" ${COMMONDEPEND}"
64RDEPEND+=" ${COMMONDEPEND}"
65unset COMMONDEPEND
118 66
119debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 67debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
120debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
121 69
122# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 70# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
150# If set to "true", $KMMODULE doesn't have to be defined. 98# If set to "true", $KMMODULE doesn't have to be defined.
151# 99#
152# Example usage: If you're installing subdirectories of a package, like plugins, 100# Example usage: If you're installing subdirectories of a package, like plugins,
153# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 101# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
154# set KMNOMODULE="true". 102# set KMNOMODULE="true".
155if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 103if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
156 KMMODULE=${PN} 104 KMMODULE=${PN}
157fi 105fi
158 106
159# @ECLASS-VARIABLE: KMEXTRA 107# @ECLASS-VARIABLE: KMEXTRA
160# @DESCRIPTION: 108# @DESCRIPTION:
161# All subdirectories listed here will be extracted, compiled & installed. 109# All subdirectories listed here will be extracted, compiled & installed.
162# $KMMODULE is always added to $KMEXTRA. 110# $KMMODULE is always added to $KMEXTRA.
163# If the doc USE-flag is set, and if this directory exists, 111# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
164# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 112# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
165# handled in the ebuild.
166# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 113# documentation in different subdirectories, it should be added to KMEXTRA manually..
167 114
168# @ECLASS-VARIABLE: KMCOMPILEONLY 115# @ECLASS-VARIABLE: KMCOMPILEONLY
169# @DESCRIPTION: 116# @DESCRIPTION:
170# All subdirectories listed here will be extracted & compiled, but not installed. 117# All subdirectories listed here will be extracted & compiled, but not installed.
171 118
253 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 200 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
254 fi 201 fi
255 else 202 else
256 local abort tarball tarfile f extractlist moduleprefix postfix 203 local abort tarball tarfile f extractlist moduleprefix postfix
257 case ${PV} in 204 case ${PV} in
258 4.2.85) 205 4.[45].8[05] | 4.[45].9[023568])
259 # block for normally packed upstream unstable snapshots 206 # Block for normally packed upstream unstable snapshots
260 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 207 KMTARPARAMS+=" --bzip2" # bz2
261 postfix="bz2" 208 postfix="bz2"
262 ;; 209 ;;
263 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*)
264 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma
265 postfix="lzma"
266 ;;
267 *) 210 *)
268 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 211 KMTARPARAMS+=" --bzip2" # bz2
269 postfix="bz2" 212 postfix="bz2"
270 ;; 213 ;;
271 esac 214 esac
272 case ${KMNAME} in 215 case ${KMNAME} in
273 kdebase-apps) 216 kdebase-apps)
274 # kdebase/apps -> kdebasa-apps 217 # kdebase/apps -> kdebase-apps
275 tarball="kdebase-${PV}.tar.${postfix}" 218 tarball="kdebase-${PV}.tar.${postfix}"
276 # Go one level deeper for kdebase-apps in tarballs 219 # Go one level deeper for kdebase-apps in tarballs
277 moduleprefix=apps/ 220 moduleprefix=apps/
278 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||" 221 KMTARPARAMS+=" --transform=s|apps/||"
279 ;; 222 ;;
280 *) 223 *)
281 # Create tarball name from module name (this is the default) 224 # Create tarball name from module name (this is the default)
282 tarball="${KMNAME}-${PV}.tar.${postfix}" 225 tarball="${KMNAME}-${PV}.tar.${postfix}"
283 ;; 226 ;;
284 esac 227 esac
285 228
286 # Full patch to source tarball 229 # Full path to source tarball
287 tarfile="${DISTDIR}/${tarball}" 230 tarfile="${DISTDIR}/${tarball}"
288 231
289 # Detect real toplevel dir from tarball name - it will be used upon extraction 232 # Detect real toplevel dir from tarball name - it will be used upon extraction
290 # and in __list_needed_subdirectories 233 # and in __list_needed_subdirectories
291 topdir="${tarball%.tar.*}/" 234 topdir="${tarball%.tar.*}/"
295 kde4-meta_create_extractlists 238 kde4-meta_create_extractlists
296 239
297 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 240 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
298 AUTHORS COPYING INSTALL README NEWS ChangeLog 241 AUTHORS COPYING INSTALL README NEWS ChangeLog
299 do 242 do
300 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 243 extractlist+=" ${topdir}${moduleprefix}${f}"
301 done 244 done
302 extractlist="${extractlist} $(__list_needed_subdirectories)" 245 extractlist+=" $(__list_needed_subdirectories)"
303 246
304 pushd "${WORKDIR}" > /dev/null 247 pushd "${WORKDIR}" > /dev/null
305 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 248 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
306 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 249 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
307 250
336# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 279# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
337# KMEXTRACTONLY and KMTARPARAMS. 280# KMEXTRACTONLY and KMTARPARAMS.
338kde4-meta_create_extractlists() { 281kde4-meta_create_extractlists() {
339 debug-print-function ${FUNCNAME} "$@" 282 debug-print-function ${FUNCNAME} "$@"
340 283
341 # TODO change to KMEXTRA for more strict check 284 # Add default handbook locations
342 if has doc ${IUSE//+} && use doc && [[ -n ${KMMODULE} ]]; then 285 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
286 if ! slot_is_at_least 4.5 ${SLOT} && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then
343 # We use the basename of $KMMODULE because $KMMODULE can contain 287 # We use the basename of $KMMODULE because $KMMODULE can contain
344 # the path to the module subdirectory. 288 # the path to the module subdirectory.
289 KMEXTRA_NONFATAL+="
290 doc/${KMMODULE##*/}"
291 fi
292
293 # Add default handbook locations
294 if [[ -z ${KMNOMODULE} ]] && { [[ ${KDE_HANDBOOK} = always ]] || { [[ ${KDE_HANDBOOK} = optional ]] && use handbook; }; }; then
345 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 295 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
346 fi 296 fi
347 297
348 # Add some CMake-files to KMEXTRACTONLY. 298 # Add some CMake-files to KMEXTRACTONLY.
349 # Note that this actually doesn't include KMEXTRA handling. 299 # Note that this actually doesn't include KMEXTRA handling.
350 # In those cases you should care to add the relevant files to KMEXTRACTONLY 300 # In those cases you should care to add the relevant files to KMEXTRACTONLY
351 case ${KMNAME} in 301 case ${KMNAME} in
352 kdebase) 302 kdebase)
353 KMEXTRACTONLY="${KMEXTRACTONLY} 303 KMEXTRACTONLY+="
354 apps/config-apps.h.cmake 304 apps/config-apps.h.cmake
355 apps/ConfigureChecks.cmake" 305 apps/ConfigureChecks.cmake"
356 ;; 306 ;;
357 kdebase-apps) 307 kdebase-apps)
358 KMEXTRACTONLY="${KMEXTRACTONLY} 308 KMEXTRACTONLY+="
359 config-apps.h.cmake 309 config-apps.h.cmake
360 ConfigureChecks.cmake" 310 ConfigureChecks.cmake"
361 ;; 311 ;;
362 kdebase-runtime) 312 kdebase-runtime)
363 KMEXTRACTONLY="${KMEXTRACTONLY} 313 KMEXTRACTONLY+="
364 config-runtime.h.cmake" 314 config-runtime.h.cmake"
365 ;; 315 ;;
366 kdebase-workspace) 316 kdebase-workspace)
367 KMEXTRACTONLY="${KMEXTRACTONLY} 317 KMEXTRACTONLY+="
368 config-unix.h.cmake 318 config-unix.h.cmake
369 ConfigureChecks.cmake 319 ConfigureChecks.cmake
370 config-workspace.h.cmake 320 config-workspace.h.cmake
371 config-X11.h.cmake 321 config-X11.h.cmake
372 startkde.cmake 322 startkde.cmake
373 KDE4WorkspaceConfig.cmake.in" 323 KDE4WorkspaceConfig.cmake.in"
374 ;; 324 ;;
375 kdegames) 325 kdegames)
376 if [[ ${PN} != libkdegames ]]; then 326 if [[ ${PN} != libkdegames ]]; then
377 KMEXTRACTONLY="${KMEXTRACTONLY} 327 KMEXTRACTONLY+="
378 libkdegames" 328 libkdegames/"
329 KMLOADLIBS="${KMLOADLIBS} libkdegames"
379 fi 330 fi
380 ;; 331 ;;
381 kdepim) 332 kdepim)
382 if [[ ${PN} != libkdepim ]]; then 333 if [[ ${PN} != libkdepim ]]; then
383 KMEXTRACTONLY="${KMEXTRACTONLY} 334 KMEXTRACTONLY+="
384 libkdepim" 335 libkdepim/"
385 fi 336 fi
386 case ${SLOT} in 337 KMEXTRACTONLY+="
387 4.3|live)
388 KMEXTRACTONLY="${KMEXTRACTONLY}
389 kdepim-version.h
390 config-enterprise.h.cmake" 338 config-enterprise.h.cmake
391 ;;
392 esac
393 KMEXTRACTONLY="${KMEXTRACTONLY}
394 kleopatra/ConfigureChecks.cmake" 339 kleopatra/ConfigureChecks.cmake"
340 if slot_is_at_least 4.5 ${SLOT}; then
341 KMEXTRACTONLY+="
342 CTestCustom.cmake
343 kdepim-version.h.cmake"
344 else
345 KMEXTRACTONLY+="
346 kdepim-version.h"
347 fi
395 if has kontact ${IUSE//+} && use kontact; then 348 if has kontact ${IUSE//+} && use kontact; then
349 KMEXTRA+="
396 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 350 kontact/plugins/${PLUGINNAME:-${PN}}/"
397 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
398 fi 351 fi
352 ;;
353 kdeutils)
354 KMEXTRACTONLY+="
355 kdeutils-version.h"
399 ;; 356 ;;
400 koffice) 357 koffice)
401 KMEXTRACTONLY="${KMEXTRACTONLY} 358 KMEXTRACTONLY+="
402 config-endian.h.cmake 359 config-endian.h.cmake
403 filters/config-filters.h.cmake 360 filters/config-filters.h.cmake
404 config-openctl.h.cmake
405 config-openexr.h.cmake 361 config-openexr.h.cmake
406 config-opengl.h.cmake 362 config-opengl.h.cmake
407 config-prefix.h.cmake" 363 config-prefix.h.cmake
364 "
365 case ${PV} in
366 2.0.*)
367 KMEXTRACTONLY+="
368 config-openctl.h.cmake"
369 ;;
370 esac
408 ;; 371 ;;
409 esac 372 esac
410 # Don't install cmake modules for split ebuilds, to avoid collisions. 373 # Don't install cmake modules for split ebuilds, to avoid collisions.
411 case ${KMNAME} in 374 case ${KMNAME} in
412 kdepim)
413 # No need for unpack since 4.2.86
414 # Remove when 4.2 is wiped out from the tree
415 case ${PV} in
416 4.1*|4.2.0|4.2.1|4.2.2|4.2.3|4.2.4|4.2.85)
417 KMCOMPILEONLY="${KMCOMPILEONLY}
418 cmake/modules/"
419 ;;
420 *) ;;
421 esac
422 ;;
423 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics) 375 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
424 case ${PN} in 376 case ${PN} in
425 libkdegames|libkdeedu|libkworkspace) 377 libkdegames|libkdeedu|libkworkspace)
426 KMEXTRA="${KMEXTRA} 378 KMEXTRA+="
427 cmake/modules/" 379 cmake/modules/"
428 ;; 380 ;;
429 *) 381 *)
430 KMCOMPILEONLY="${KMCOMPILEONLY} 382 KMCOMPILEONLY+="
431 cmake/modules/" 383 cmake/modules/"
432 ;; 384 ;;
433 esac 385 esac
434 ;; 386 ;;
435 esac 387 esac
440__list_needed_subdirectories() { 392__list_needed_subdirectories() {
441 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 393 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
442 394
443 # We expand KMEXTRA by adding CMakeLists.txt files 395 # We expand KMEXTRA by adding CMakeLists.txt files
444 kmextra="${KMEXTRA}" 396 kmextra="${KMEXTRA}"
445 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 397 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
446 for i in ${kmextra}; do 398 for i in ${kmextra}; do
447 kmextra_expanded="${kmextra_expanded} ${i}" 399 kmextra_expanded+=" ${i}"
448 j=$(dirname ${i}) 400 j=$(dirname ${i})
449 while [[ ${j} != "." ]]; do 401 while [[ ${j} != "." ]]; do
450 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 402 kmextra_expanded+=" ${j}/CMakeLists.txt";
451 j=$(dirname ${j}) 403 j=$(dirname ${j})
452 done 404 done
453 done 405 done
454 406
455 # Expand KMMODULE 407 # Expand KMMODULE
456 if [[ -n ${KMMODULE} ]]; then 408 if [[ -n ${KMMODULE} ]]; then
457 kmmodule_expanded="${KMMODULE}" 409 kmmodule_expanded="${KMMODULE}"
458 j=$(dirname ${KMMODULE}) 410 j=$(dirname ${KMMODULE})
459 while [[ ${j} != "." ]]; do 411 while [[ ${j} != "." ]]; do
460 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 412 kmmodule_expanded+=" ${j}/CMakeLists.txt";
461 j=$(dirname ${j}) 413 j=$(dirname ${j})
462 done 414 done
463 fi 415 fi
464 416
465 # Expand KMCOMPILEONLY 417 # Expand KMCOMPILEONLY
466 for i in ${KMCOMPILEONLY}; do 418 for i in ${KMCOMPILEONLY}; do
467 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 419 kmcompileonly_expanded+=" ${i}"
468 j=$(dirname ${i}) 420 j=$(dirname ${i})
469 while [[ ${j} != "." ]]; do 421 while [[ ${j} != "." ]]; do
470 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 422 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
471 j=$(dirname ${j}) 423 j=$(dirname ${j})
472 done 424 done
473 done 425 done
474 426
475 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 427 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
479 # Create final list of stuff to extract 431 # Create final list of stuff to extract
480 # We append topdir only when specified (usually for tarballs) 432 # We append topdir only when specified (usually for tarballs)
481 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 433 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
482 ${KMEXTRACTONLY} 434 ${KMEXTRACTONLY}
483 do 435 do
484 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 436 extractlist+=" ${topdir}${moduleprefix}${i}"
485 done 437 done
486 438
487 echo ${extractlist} 439 echo ${extractlist}
488} 440}
489 441
513 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 465 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
514 fi 466 fi
515 done 467 done
516} 468}
517 469
518# FIXME: add description
519# @FUNCTION: kde4-meta_change_cmakelists 470# @FUNCTION: kde4-meta_change_cmakelists
520# @DESCRIPTION: 471# @DESCRIPTION:
472# Adjust CMakeLists.txt to comply to our splitting.
521kde4-meta_change_cmakelists() { 473kde4-meta_change_cmakelists() {
522 debug-print-function ${FUNCNAME} "$@" 474 debug-print-function ${FUNCNAME} "$@"
523 475
524 pushd "${S}" > /dev/null 476 pushd "${S}" > /dev/null
525 477
526 comment_all_add_subdirectory ./ 478 comment_all_add_subdirectory ./
527 479
528 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 480 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
529 if [[ -f "${S}"/CMakeLists.txt ]]; then 481 if [[ -f CMakeLists.txt ]]; then
530 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 482 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
531 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 483 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
532 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 484 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
533 fi 485 fi
534 486
535 if [[ -z ${KMNOMODULE} ]]; then 487 if [[ -z ${KMNOMODULE} ]]; then
536 # Restore "add_subdirectory" in $KMMODULE subdirectories 488 # Restore "add_subdirectory" in $KMMODULE subdirectories
537 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 489 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
490 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
538 die "${LINENO}: died in KMMODULE section" 491 die "${LINENO}: died in KMMODULE section"
539 _change_cmakelists_parent_dirs ${KMMODULE} 492 _change_cmakelists_parent_dirs ${KMMODULE}
540 fi 493 fi
541 494
542 local i 495 local i
543 496
544 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 497 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
545 for i in ${KMEXTRACTONLY}; do 498 for i in ${KMEXTRACTONLY}; do
546 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 499 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
547 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 500 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
501 -i ${i}/../CMakeLists.txt || \
548 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 502 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
549 fi 503 fi
550 done 504 done
551 505
552 # KMCOMPILEONLY 506 # KMCOMPILEONLY
574 # KMEXTRA_NONFATAL section 528 # KMEXTRA_NONFATAL section
575 for i in ${KMEXTRA_NONFATAL}; do 529 for i in ${KMEXTRA_NONFATAL}; do
576 if [[ -d "${S}"/${i} ]]; then 530 if [[ -d "${S}"/${i} ]]; then
577 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 531 find "${S}"/${i} -name CMakeLists.txt -print0 | \
578 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 532 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
579 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 533 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
580 _change_cmakelists_parent_dirs ${i} 534 _change_cmakelists_parent_dirs ${i}
581 fi 535 fi
582 done 536 done
583 537
584 case ${KMNAME} in 538 case ${KMNAME} in
585 kdebase-workspace) 539 kdebase-workspace)
586 # COLLISION PROTECT section 540 # COLLISION PROTECT section
587 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 541 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
588 # not as a part of every package. 542 # not as a part of every package.
589 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 543 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
590 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 544 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
591 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 545 sed -e '/startkde/s/^/#DONOTINSTALL /' \
592 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 546 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
593 fi 547 fi
594 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 548 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
595 if [[ ${PN} != libkworkspace ]]; then 549 if [[ ${PN} != libkworkspace ]]; then
596 sed -i \
597 -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 550 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
598 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section" 551 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
599 fi 552 fi
600 ;; 553 ;;
601 kdebase-runtime) 554 kdebase-runtime)
602 # COLLISION PROTECT section 555 # COLLISION PROTECT section
603 # Only install the kde4 script as part of kde-base/kdebase-data 556 # Only install the kde4 script as part of kde-base/kdebase-data
604 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 557 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
605 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 558 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
606 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 559 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
607 fi 560 fi
561 ;;
562 kdenetwork)
563 # Disable hardcoded kdepimlibs check
564 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
565 -i CMakeLists.txt || die "failed to disable hardcoded checks"
608 ;; 566 ;;
609 kdepim) 567 kdepim)
568 # Disable hardcoded checks
569 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
570 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
571 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
572 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
573 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
574 -i CMakeLists.txt || die "failed to disable hardcoded checks"
575 # Disable broken or redundant build logic
576 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
577 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
578 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
579 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
580 fi
581 if ! slot_is_at_least 4.5 ${SLOT}; then
610 case ${PN} in 582 case ${PN} in
611 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 583 kalarm|kmailcvt|kontact|korganizer|korn)
612 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 584 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
613 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 585 -e '/add_custom_target(kmail_xml /,/)/p' \
586 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
614 _change_cmakelists_parent_dirs kmail 587 _change_cmakelists_parent_dirs kmail
615 ;; 588 ;;
616 esac 589 esac
590 fi
617 ;; 591 ;;
618 kdewebdev) 592 kdewebdev)
619 # Disable hardcoded kdepimlibs check 593 # Disable hardcoded checks
620 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 594 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
621 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \ 595 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
622 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \ 596 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
623 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \ 597 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
624 -i CMakeLists.txt || die "failed to disable hardcoded checks" 598 -i CMakeLists.txt || die "failed to disable hardcoded checks"
625 ;; 599 ;;
626 koffice) 600 koffice)
627 # prevent collisions 601 # Prevent collisions
628 if [[ ${PN} != koffice-data ]]; then 602 if [[ ${PN} != koffice-data ]]; then
629 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 603 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
630 "${S}"/cmake/modules/CMakeLists.txt || \ 604 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
605 sed -e '/install(.\+config-openexr\.h.\+)/d' \
631 die "${LINENO}: sed died in collision prevention section" 606 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
607 fi
608 # koffice 2.0
609 case ${PV} in
610 2.0.[1-9])
632 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \ 611 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
633 "${S}"/CMakeLists.txt || \ 612 "${S}"/CMakeLists.txt || \
634 die "${LINENO}: sed died in collision prevention section" 613 die "${LINENO}: sed died in collision prevention section"
614 ;;
615 *) ;;
616 esac
617 # koffice 2.1.[8-9][0-9] and 9999
618 case ${PV} in
619 2.1.8[0-9]|2.1.9[0-9]|9999)
620 sed -e '/^option(BUILD/s/ON/OFF/' \
621 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
622 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
623 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
624 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
625 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
626 sed -e '/config-opengl.h/d' \
627 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
628
635 fi 629 fi
630 ;;
631 *) ;;
632 esac
636 esac 633 esac
637 634
638 popd > /dev/null 635 popd > /dev/null
639} 636}
640 637
643# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 640# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
644# ebuilds. 641# ebuilds.
645kde4-meta_src_configure() { 642kde4-meta_src_configure() {
646 debug-print-function ${FUNCNAME} "$@" 643 debug-print-function ${FUNCNAME} "$@"
647 644
645 # backwards-compatibility: make mycmakeargs an array, if it isn't already
646 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
647 mycmakeargs=(${mycmakeargs})
648 fi
649
648 # Set some cmake default values here (usually workarounds for automagic deps) 650 # Set some cmake default values here (usually workarounds for automagic deps)
649 case ${KMNAME} in 651 case ${KMNAME} in
650 kdewebdev) 652 kdewebdev)
651 mycmakeargs=" 653 mycmakeargs=(
652 -DWITH_KdepimLibs=OFF 654 -DWITH_KdepimLibs=OFF
653 -DWITH_LibXml2=OFF 655 -DWITH_LibXml2=OFF
654 -DWITH_LibXslt=OFF 656 -DWITH_LibXslt=OFF
655 -DWITH_Boost=OFF 657 -DWITH_Boost=OFF
656 -DWITH_LibTidy=OFF 658 -DWITH_LibTidy=OFF
657 ${mycmakeargs}" 659 "${mycmakeargs[@]}"
660 )
661 ;;
662 koffice)
663 case ${PV} in
664 2.1.8[0-9]|2.1.9[0-9]|9999)
665 if [[ ${PN} != "kchart" ]]; then
666 mycmakeargs=(
667 -DBUILD_koreport=OFF
668 "${mycmakeargs[@]}"
669 )
670 fi
671 ;;
672 esac
658 ;; 673 ;;
659 esac 674 esac
660 675
661 kde4-base_src_configure 676 kde4-base_src_configure
662} 677}
666# General function for compiling split KDE4 applications. 681# General function for compiling split KDE4 applications.
667# Overrides kde4-base_src_compile. 682# Overrides kde4-base_src_compile.
668kde4-meta_src_compile() { 683kde4-meta_src_compile() {
669 debug-print-function ${FUNCNAME} "$@" 684 debug-print-function ${FUNCNAME} "$@"
670 685
671 kde4-base_src_compile 686 kde4-base_src_compile "$@"
672} 687}
673 688
674# @FUNCTION: kde4-meta_src_test 689# @FUNCTION: kde4-meta_src_test
675# @DESCRIPTION: 690# @DESCRIPTION:
676# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 691# Currently just calls its equivalent in kde4-base.eclass(5) if
677# ebuilds. 692# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
678kde4-meta_src_test() { 693kde4-meta_src_test() {
679 debug-print-function $FUNCNAME "$@" 694 debug-print-function $FUNCNAME "$@"
680 695
696 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
681 kde4-base_src_test 697 kde4-base_src_test
698 else
699 einfo "Tests disabled"
700 fi
682} 701}
683 702
684# @FUNCTION: kde4-meta_src_install 703# @FUNCTION: kde4-meta_src_install
685# @DESCRIPTION: 704# @DESCRIPTION:
686# Function for installing KDE4 split applications. 705# Function for installing KDE4 split applications.
687kde4-meta_src_install() { 706kde4-meta_src_install() {
688 debug-print-function $FUNCNAME "$@" 707 debug-print-function $FUNCNAME "$@"
689 708
709 # Search ${S}/${KMMODULE} and install common documentation files found
710 local doc
711 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
712 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
713 done
714
690 kde4-base_src_install 715 kde4-base_src_install
691} 716}
692 717
693# @FUNCTION: kde4-meta_src_make_doc
694# @DESCRIPTION:
695# This function searches in ${S}/${KMMODULE},
696# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
697kde4-meta_src_make_doc() {
698 debug-print-function ${FUNCNAME} "$@"
699
700 local doc
701 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
702 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
703 done
704
705 kde4-base_src_make_doc
706}
707
708# @FUNCTION: kde4-meta_pkg_postinst 718# @FUNCTION: kde4-meta_pkg_postinst
709# @DESCRIPTION: 719# @DESCRIPTION:
710# Display information about application handbook and invoke kbuildsycoca4. 720# Invoke kbuildsycoca4.
711kde4-meta_pkg_postinst() { 721kde4-meta_pkg_postinst() {
712 debug-print-function ${FUNCNAME} "$@" 722 debug-print-function ${FUNCNAME} "$@"
713
714 if has doc ${IUSE//+} && ! use doc; then
715 echo
716 einfo "Application handbook for ${PN} has not been installed."
717 einfo "To install handbook, reemerge =${CATEGORY}/${P} with 'doc' USE flag."
718 echo
719 fi
720 723
721 kde4-base_pkg_postinst 724 kde4-base_pkg_postinst
722} 725}
723 726
724# @FUNCTION: kde4-meta_pkg_postrm 727# @FUNCTION: kde4-meta_pkg_postrm

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.43

  ViewVC Help
Powered by ViewVC 1.1.20